<?php
/* --------------------------------------------------------------------------------------
$Id: micropayment_elv_ipn.php 136 2009-01-25 08:00:00Z hhgag $

H.H.G. group Ltd.

http://www.hhg-group.com/

Copyright (c) 2005-2009 H.H.G. group Ltd.
-----------------------------------------------------------------------------------------
Released under the GNU General Public License
----------------------------------------------------------------------------------------- */
/**
 *
 *
 * @version Micropayment Lastschrift (ELV)-Modul 1.1  16.02.2009
 * @author Michael Cici  info@skyline-service.de
 * @copyright 2009 Michael Cici
 * @link http://www.skyline-service.de
 * @link http://www.xt-commerce.com
 * @link http://www.micropayment.de
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 ***********************************************************************************
 * this file contains code based on:
 * (c) 2000 - 2001 The Exchange Project
 * (c) 2001 - 2003 osCommerce, Open Source E-Commerce Solutions
 * (c) 2003	 nextcommerce (account_history_info.php,v 1.17 2003/08/17); www.nextcommerce.org
 * (c) 2003 - 2006 XT-Commerce
 * (c) 2003 - 2006 XT-Commerce
 * (c) 2006 - 2008 Henri Schmidhuber
 * Released under the GNU General Public License
 ***********************************************************************************
 *
 */

//#############################################################################################
//## VORGABEVARIABLEN (entsprechend anpassen)
//
  $forward           = 1;				/* 0 = User muss Button fuer Weiterleitung druecken | 1 = automatische Weiterleitung */
  $target            = '_top';			/* Zielfenster Standard = '_blank' */
  $trenner           = "\n";				/* Trennzeichen */

  //== Bestaetigungs-eMail von Micropayment mit Transaktionsnummer ueber positiven 
  //== Zahlungseingang an Kaeufer uebermitteln.
  //== (Standard = 0 = deaktiviert)
  //
    define('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_EMAIL_PAY_SUCCESS', 0); // Hinweis: 0 = generell keine Bestaetigungs-eMail versenden | 1 = Bestaetigungs-eMail versenden

    define('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_EMAIL_PAY_SUCCESS_ADD_BEFORE', "Sehr geehrter Kunde, sehr geehrte Kundin,<br /><br />Wir bedanken uns fuer Ihren Einkauf.<br />Ihre Zahlung wurde bestaetigt und Ihre bestellten Artikel werden umgehend an Sie versendet.<br /><br />"); // Dies ist ein erweiterbarer Zusatztext (Anfang) in der eMail.
    define('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_EMAIL_PAY_SUCCESS_ADD_AFTER', "Mit freundlichen Gruessen,<br /><b>Ihr Shopbetreiber</b><br />"); // Dies ist ein erweiterbarer Zusatztext (Ende) in der eMail.
//
//##
//#############################################################################################


//## AB HIER KEINE AENDERUNG MEHR NOETIG


//#############################################################################################
//## Erklaerung:
//##
//## Zuerst wird ueberprueft, ob eine gueltige Belegnummer (Variable Nummer != NULL , 
//## ist Nummer numerisch und ist Nummer groesser als 0).
//## Danach pruefen wir, ob der Rechnungsbetrag (geteilt durch Hundert, da Micropayment den
//## $amount in der kleinstmoeglichen Waehrung (Cent) zurueckgibt) mit dem aus unserer Daten-
//## bank uebereinstimmt. Ebenso die Kundennummer und die Landeswaehrung.
//## Erst wenn alle Einstellungen stimmen, gehts weiter (Bestellstatusaenderungen durch die API)
//## Im Fehlerfall wird eine eMail an die Debug-e-Mail-Adresse versendet, so fern eine in der
//## Schnittstelle angegeben wurde.
//##
//##
//
  chdir('../../../../');
  require ('includes/application_top.php');

  $mp_elv_transaktions_details = array();

  $function          = $_GET['function'];		/* Zahlungsstatus billing|storno|backpay */
  $title             = $_GET['title'];		/* Artikeltitel (Ohne wirkliche Verwendung)*/
  $currency          = $_GET['currency'];		/* Waehrungscode */
  $auth              = $_GET['auth'];		/* Authorisierungscode */
  $country           = $_GET['country'];		/* Landescode ISO 2stellig */
  $customerid        = $_GET['customerid'];	/* Kundennummer */
  $orderid           = $_GET['orderid'];		/* Bestellnummer/Rechnungsnummer */

  $orderid = $customerid = $amount = '';

  if(!empty($_GET['orderid'])) {
	$orderid = $_GET['orderid'];
  }
  if(!empty($_GET['customerid'])) {
	$customerid = $_GET['customerid'];
  }
  if(!empty($_GET['amount'])) {
	$amount = number_format($_GET['amount'], 2, '.', '') / 100;
  }

  //== Pruefen, ob Auftrag und/oder Kundennummer existiert
  if (empty($orderid)) {
	exit('no orderid');
  }
  if (empty($customerid)) {
	exit('no customerid');
  }
  if (!is_numeric($orderid)) {
	exit('no numeric orderid');
  }
  if ($orderid <= 0) {
	exit('orderid <= 0');
  }

  $comment           = '';
  $error_text        = '';
  $error             = false;
  $customer_notified = 0;

  if (strlen(MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PROJECT_PASSWORD) < 1) {
	$error_text .= 'ung&uuml;ltiges Projektpasswort / invalid Projectpassword' . "\n";
	$error = true;
  }
  if ($_GET['currency'] != MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_CURRENCY) {
	$error_text .= 'W&auml;hrungen passen nicht &uuml;berein  / Currency doesnt\'t match:' . "\n";
	$error = true;
  }

  $connector = '?';
  foreach ($_GET as $key => $value) {
	$parameters .= $connector . $key . '=' . urlencode(stripslashes($value));
	if($connector == '?') $connector = '&'; 
  }

  $order_query  = xtc_db_query("select * from " . TABLE_ORDERS . " where orders_id = '" . (int) $orderid . "' and customers_id = '" . (int) $customerid . "'");

  if(xtc_db_num_rows($order_query) > 0) {

	$order = xtc_db_fetch_array($order_query);

	if(!empty($order['mp_elv_transaktions_details']))
		$mp_elv_transaktions_details = unserialize($order['mp_elv_transaktions_details']);

	$total_query  = xtc_db_query("select value from " . TABLE_ORDERS_TOTAL . " where orders_id = '" . (int) $orderid . "' and class = 'ot_total' limit 1");
	$total        = xtc_db_fetch_array($total_query);

	$order_total  = number_format($total['value'] / $order['currency_value'], 2, '.', '');

	if($amount == $order_total) {

		$comment_status = '(' . $amount . ' ' . $currency . '; Transaktions-ID: ' . $auth . ')';

		switch($function) {

			case 'billing':
				$comment      = 'Micropayment Lastschrift (ELV) OK [' . $comment_status . ']';
				$order_status = (MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ORDER_STATUS_ID > 0 ? (int) MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ORDER_STATUS_ID : (int) DEFAULT_ORDERS_STATUS_ID);


				//-- Rechnungs-eMail versenden

				require_once (DIR_FS_INC.'xtc_get_order_data.inc.php');
				require_once (DIR_FS_INC.'xtc_get_attributes_model.inc.php');
				require_once (DIR_FS_INC.'xtc_address_label.inc.php');
				require_once (DIR_WS_CLASSES.'order.php');

				$smarty = new Smarty;

				$order_invoice = new order($orderid);

				$smarty->assign('address_label_customer', xtc_address_format($order_invoice->customer['format_id'], $order_invoice->customer, 1, '', '<br />'));
				$smarty->assign('address_label_shipping', xtc_address_format($order_invoice->delivery['format_id'], $order_invoice->delivery, 1, '', '<br />'));
				if ($_SESSION['credit_covers'] != '1') {
					$smarty->assign('address_label_payment', xtc_address_format($order_invoice->billing['format_id'], $order_invoice->billing, 1, '', '<br />'));
				}
				$smarty->assign('csID', $order_invoice->customer['csID']);
	
				$order_total_invoice = $order_invoice->getTotalData($orderid); 
					$smarty->assign('order_data', $order_invoice->getOrderData($orderid));
					$smarty->assign('order_total', $order_total_invoice['data']);

				// assign language to template for caching
				$smarty->assign('language', $_SESSION['language']);
				$smarty->assign('tpl_path', 'templates/'.CURRENT_TEMPLATE.'/');
				$smarty->assign('logo_path', HTTP_SERVER.DIR_WS_CATALOG.'templates/'.CURRENT_TEMPLATE.'/img/');
				$smarty->assign('oID', $orderid);
				if ($order_invoice->info['payment_method'] != '' && $order_invoice->info['payment_method'] != 'no_payment') {
					include (DIR_WS_LANGUAGES.$_SESSION['language'].'/modules/payment/'.$order_invoice->info['payment_method'].'.php');
					$payment_method = constant(strtoupper('MODULE_PAYMENT_'.$order_invoice->info['payment_method'].'_TEXT_TITLE'));
				}
				$smarty->assign('PAYMENT_METHOD', $payment_method);
				$smarty->assign('DATE', xtc_date_long($order_invoice->info['date_purchased']));

				$smarty->assign('NAME', $order_invoice->customer['name']);
				$smarty->assign('COMMENTS', $order_invoice->info['comments']);
				$smarty->assign('EMAIL', $order_invoice->customer['email_address']);
				$smarty->assign('PHONE',$order_invoice->customer['telephone']);

				// dont allow cache
				$smarty->caching = false;

				$html_mail = $smarty->fetch(CURRENT_TEMPLATE.'/mail/'.$_SESSION['language'].'/order_mail.html');
				$txt_mail = $smarty->fetch(CURRENT_TEMPLATE.'/mail/'.$_SESSION['language'].'/order_mail.txt');

				// create subject
				$order_subject = str_replace('{$nr}', $orderid, EMAIL_BILLING_SUBJECT_ORDER);
				$order_subject = str_replace('{$date}', strftime(DATE_FORMAT_LONG), $order_subject);
				$order_subject = str_replace('{$lastname}', $order->customer['lastname'], $order_subject);
				$order_subject = str_replace('{$firstname}', $order->customer['firstname'], $order_subject);

				// send mail to admin
				xtc_php_mail(EMAIL_BILLING_ADDRESS, EMAIL_BILLING_NAME, EMAIL_BILLING_ADDRESS, STORE_NAME, EMAIL_BILLING_FORWARDING_STRING, $order_invoice->customer['email_address'], $order_invoice->customer['firstname'], '', '', $order_subject, $html_mail, $txt_mail);

				// send mail to customer
				xtc_php_mail(EMAIL_BILLING_ADDRESS, EMAIL_BILLING_NAME, $order_invoice->customer['email_address'], $order_invoice->customer['firstname'].' '.$order_invoice->customer['lastname'], '', EMAIL_BILLING_REPLY_ADDRESS, EMAIL_BILLING_REPLY_ADDRESS_NAME, '', '', $order_subject, $html_mail, $txt_mail);


				//-- Micropayment-Status-e-Mail versenden
				if(MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_EMAIL_PAY_SUCCESS == 1) {
					$email_subject   = STORE_NAME.': Zahlungseingang per Micropayment (Lastschrift (ELV)) bestaetigt';
					$email_body_html  = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_EMAIL_PAY_SUCCESS_ADD_BEFORE . 'Bestellnummer: ' . (int) $orderid . "<br /><br />" . "Nachricht:\n" . $comment . "<br /><br />" . MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_EMAIL_PAY_SUCCESS_ADD_AFTER;
					$email_body_txt   = str_replace("<br />", '\n', $email_body_txt  );
					$email_body_txt   = strip_tags($email_body_txt);

					xtc_php_mail(EMAIL_BILLING_ADDRESS, EMAIL_BILLING_NAME, EMAIL_BILLING_ADDRESS, STORE_NAME, EMAIL_BILLING_FORWARDING_STRING, EMAIL_BILLING_ADDRESS, STORE_NAME, '', '', $email_subject, $email_body_html, $email_body_txt);
				}


				$customer_notified = '1';
				break;

			case 'storno':
				$comment       = 'Micropayment Lastschrift (ELV) STORNO [' . $comment_status . ']';
				$email_subject = 'STORNO: Micropayment Lastschrift (ELV) IPN';
				$order_status  = (MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_UNC_STATUS_ID > 0 ? (int) MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_UNC_STATUS_ID : (int) DEFAULT_ORDERS_STATUS_ID);
				break;

			case 'backpay':
				$comment       = 'Micropayment Lastschrift (ELV) BACKPAY [' . $comment_status . ']';
				$email_subject = 'BACKPAY: Micropayment Lastschrift (ELV) IPN';
				$order_status  = (MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ORDER_STATUS_ID > 0 ? (int) MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ORDER_STATUS_ID : (int) DEFAULT_ORDERS_STATUS_ID);
				break;

		}

		//-- eMail-Benachrichtigung an den Shopbetreiber versenden bei billing, storno oder backpay
		if(xtc_not_null(MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_DEBUG_EMAIL)) {

			if($function == 'storno' || $function == 'backpay') {
				$email_body_txt  = NULL;
				$email_body_html = NULL;
				foreach ($_GET as $key => $value) {
					$email_body_txt  .= $key . '=' . $value . "\n";
					$email_body_html .= $key . '=' . $value . "<br />";
				}
				xtc_php_mail(MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_DEBUG_EMAIL, STORE_OWNER , MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_DEBUG_EMAIL, STORE_OWNER, '', MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_DEBUG_EMAIL, STORE_OWNER, '', '', $email_subject, $email_body_html, $email_body_txt);
			}

			if($function == 'billing') {
				$email_subject    = 'BILLING: Micropayment Lastschrift (ELV) IPN';
				$email_body_html  = 'Bestellnummer: ' . (int) $orderid . "<br /><br />" . "Nachricht:\n" . $comment;
				$email_body_txt   = str_replace("<br />", '\n', $email_body_txt  );
				$email_body_txt   = strip_tags($email_body_txt);
				xtc_php_mail(MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_DEBUG_EMAIL, STORE_OWNER , MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_DEBUG_EMAIL, STORE_OWNER, '', MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_DEBUG_EMAIL, STORE_OWNER, '', '', $email_subject, $email_body_html, $email_body_txt);
			}

		}

		$htt_redir_url = HTTP_SERVER;
		if (ENABLE_SSL == 'true') {
			$htt_redir_url = HTTPS_SERVER;
		}

		$url       = $htt_redir_url . DIR_WS_CATALOG . FILENAME_CHECKOUT_SUCCESS . $parameters;

		//-- Warenkorb leeren nach erfolgreicher Abwicklung - von Heinz-Jrgen Jonuschies. 
		$_SESSION['cart']->reset(true);
 
		// unregister session variables used during checkout
		unset ($_SESSION['sendto']);
		unset ($_SESSION['billto']);
		unset ($_SESSION['shipping']);
		unset ($_SESSION['payment']);
		unset ($_SESSION['comments']); 

		$status    = 'ok';

	} else {

		$error_text .= "Betr&auml;ge stimmen nicht &uuml;berein. Amount doesn't match\n" . ($amount) . '!=' . ($order_total) . "\n";
		$error = true;

		$status    = 'error';

	}


	if ($error == true) {
		$comment       = 'Micropayment Lastschrift (ELV) IPN Ungueltiger Prozess';
		$error_text    = 'Fehler w&auml;hrend der Transaktion (Callback)' . "\n" . $error_text;
		$_GET['error'] = $error_text;
		$order_status  = (MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_UNC_STATUS_ID > 0 ? (int) MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_UNC_STATUS_ID : (int) DEFAULT_ORDERS_STATUS_ID);
	}
	$sql_data_array = array('orders_id' => (int) $orderid , 'orders_status_id' => $order_status , 'date_added' => 'now()' , 'customer_notified' => $customer_notified , 'comments' => $comment);
	xtc_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
	xtc_db_query("update " . TABLE_ORDERS . " set orders_status = '" . $order_status . "', last_modified = now() where orders_id = '" . (int) $orderid . "'");


	if ($error == true && xtc_not_null(MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_DEBUG_EMAIL)) {
		$email_subject   = 'Micropayment Lastschrift (ELV) IPN Ungueltiger Prozess';
		$email_body_txt  = NULL;
		$email_body_html = NULL;
		foreach ($_GET as $key => $value) {
			$email_body_txt  .= $key . '=' . $value . "\n";
			$email_body_html .= $key . '=' . $value . "<br />";
		}
		xtc_php_mail(MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_DEBUG_EMAIL, STORE_OWNER , MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_DEBUG_EMAIL, STORE_OWNER, '', MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_DEBUG_EMAIL, STORE_OWNER, '', '', $email_subject, $email_body_html, $email_body_txt);
	}

	$sofortueberweisung_transaktions_details['get'] = $_GET;
	xtc_db_query("update " . TABLE_ORDERS . " set mp_elv_transaktions_details = '" . xtc_db_input(serialize($mp_elv_transaktions_details)) . "', last_modified = now() where orders_id = '" . (int) $orderid . "'");


	$response  = 'order_total=' . $order_total;
	$response .= $trenner;
	$response .= 'amount=' . $amount;
	$response .= $trenner;
	$response .= 'status=' . $status;
	$response .= $trenner;
	$response .= 'url=' . $url;
	$response .= $trenner;
	$response .= 'target=' . $target;
	$response .= $trenner;
	$response .= 'forward=' . $forward;
	$response .= $trenner;

	echo $response;


  } else {
	exit('Order not found:' . $orderid);
  }
//
//#############################################################################################
?>