<?php
/* --------------------------------------------------------------------------------------
$Id: micropayment_elv_ipn.php 136 2009-01-25 08:00:00Z hhgag $

H.H.G. group Ltd.

http://www.hhg-group.com/

Copyright (c) 2005-2009 H.H.G. group Ltd.
-----------------------------------------------------------------------------------------
Released under the GNU General Public License
----------------------------------------------------------------------------------------- */
/**
 *
 *
 * @version Micropayment Lastschrift (ELV)-Modul 1.1  16.02.2009
 * @author Michael Cici  info@skyline-service.de
 * @copyright 2009 Michael Cici
 * @link http://www.skyline-service.de
 * @link http://www.xt-commerce.com
 * @link http://www.micropayment.de
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 ***********************************************************************************
 * this file contains code based on:
 * (c) 2000 - 2001 The Exchange Project
 * (c) 2001 - 2003 osCommerce, Open Source E-Commerce Solutions
 * (c) 2003	 nextcommerce (account_history_info.php,v 1.17 2003/08/17); www.nextcommerce.org
 * (c) 2003 - 2006 XT-Commerce
 * (c) 2003 - 2006 XT-Commerce
 * (c) 2006 - 2008 Henri Schmidhuber
 * Released under the GNU General Public License
 ***********************************************************************************
 *
 */

define('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_TMP_STATUS_NAME', 'Bestellung nicht abgeschlossen'); // max 32 chars. Do not change after install.

class micropayment_elv_ipn
{
	var $code, $title, $description, $enabled;
	function micropayment_elv_ipn ()
	{
		global $order;
		$this->code = 'micropayment_elv_ipn';
		$this->title = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_TEXT_TITLE;
		$this->description = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_TEXT_DESCRIPTION;
		$this->sort_order = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_SORT_ORDER;
		$this->enabled = ((MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_STATUS == 'True') ? true : false);
		$this->info = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_TEXT_INFO;
		$this->tmpOrders = true;
		$this->tmpStatus = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_TMP_STATUS_ID;
		if ((int) MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ORDER_STATUS_ID > 0) {
			$this->order_status = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ORDER_STATUS_ID;
		}
		if (is_object($order))
			$this->update_status();
		$this->form_action_url = 'http://billing.micropayment.de/lastschrift/event/';

	}
	function update_status ()
	{
		global $order;
		if (($this->enabled == true) && ((int) MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ZONE > 0)) {
			$check_flag = false;
			$check_query = xtc_db_query("SELECT zone_id FROM " . TABLE_ZONES_TO_GEO_ZONES . " WHERE geo_zone_id = '" . MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' ORDER BY zone_id");
			while ($check = xtc_db_fetch_array($check_query)) {
				if ($check['zone_id'] < 1) {
					$check_flag = true;
					break;
				} elseif ($check['zone_id'] == $order->billing['zone_id']) {
					$check_flag = true;
					break;
				}
			}
			if ($check_flag == false) {
				$this->enabled = false;
			}
		}
	}
	function javascript_validation ()
	{
		return false;
	}
	function selection ()
	{
		global $order, $currencies;

		if ($order->info['total'] >= MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_MIN_TOTAL && 
		    $order->info['total'] <= MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_MAX_TOTAL )  {


			if (! empty($_SESSION['cart_mp_elv_ID'])) {
				$orderid = substr($_SESSION['cart_mp_elv_ID'], strpos($_SESSION['cart_mp_elv_ID'], '-') + 1);
				$check_query = xtc_db_query('SELECT orders_status FROM ' . TABLE_ORDERS . ' WHERE orders_id = "' . (int) $orderid . '" LIMIT 1');
				if ($result = xtc_db_fetch_array($check_query)) {
					if ($result['orders_status'] == MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_TMP_STATUS_ID) {
						xtc_db_query('DELETE FROM ' . TABLE_ORDERS . ' WHERE orders_id = "' . (int) $orderid . '"');
						xtc_db_query('DELETE FROM ' . TABLE_ORDERS_TOTAL . ' WHERE orders_id = "' . (int) $orderid . '"');
						xtc_db_query('DELETE FROM ' . TABLE_ORDERS_STATUS_HISTORY . ' WHERE orders_id = "' . (int) $orderid . '"');
						xtc_db_query('DELETE FROM ' . TABLE_ORDERS_PRODUCTS . ' WHERE orders_id = "' . (int) $orderid . '"');
						xtc_db_query('DELETE FROM ' . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . ' WHERE orders_id = "' . (int) $orderid . '"');
						xtc_db_query('DELETE FROM ' . TABLE_ORDERS_PRODUCTS_DOWNLOAD . ' WHERE orders_id = "' . (int) $orderid . '"');
						unset($_SESSION['cart_mp_elv_ID']);
						unset($_SESSION['tmp_oID']);
					}
				}
			}

			$title = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_TEXT_DESCRIPTION_CHECKOUT_PAYMENT_TEXT;

			return array('id' => $this->code , 'module' => $this->title , 'description' => $title);
		}
	}
	function pre_confirmation_check ()
	{
		// Fix for XTC Bug
		// We need a cartID
		if (empty($_SESSION['cart']->cartID)) {
			$_SESSION['cart']->cartID = $_SESSION['cart']->generate_cart_id();
		}
		$_SESSION['mp_elv_cartID'] = $_SESSION['cart']->cartID;
		return false;
	}
	function confirmation ()
	{
		global $order;
		if (! empty($_SESSION['cart_mp_elv_ID'])) {
			$orderid = substr($_SESSION['cart_mp_elv_ID'], strpos($_SESSION['cart_mp_elv_ID'], '-') + 1);
			$cartID = substr($_SESSION['cart_mp_elv_ID'], 0, strlen($_SESSION['cart']->cartID));
			$check_query = xtc_db_query("SELECT currency, orders_status FROM " . TABLE_ORDERS . " WHERE orders_id = '" . (int) $orderid . "'");
			$result = xtc_db_fetch_array($check_query);
			if (($result['orders_status'] == MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_TMP_STATUS_ID) || ($result['currency'] != $order->info['currency']) || ($_SESSION['cart']->cartID != $cartID)) {
				xtc_db_query('DELETE FROM ' . TABLE_ORDERS . ' WHERE orders_id = "' . (int) $orderid . '"');
				xtc_db_query('DELETE FROM ' . TABLE_ORDERS_TOTAL . ' WHERE orders_id = "' . (int) $orderid . '"');
				xtc_db_query('DELETE FROM ' . TABLE_ORDERS_STATUS_HISTORY . ' WHERE orders_id = "' . (int) $orderid . '"');
				xtc_db_query('DELETE FROM ' . TABLE_ORDERS_PRODUCTS . ' WHERE orders_id = "' . (int) $orderid . '"');
				xtc_db_query('DELETE FROM ' . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . ' WHERE orders_id = "' . (int) $orderid . '"');
				xtc_db_query('DELETE FROM ' . TABLE_ORDERS_PRODUCTS_DOWNLOAD . ' WHERE orders_id = "' . (int) $orderid . '"');
				unset($_SESSION['cart_mp_elv_ID']);
				unset($_SESSION['tmp_oID']);
			}
		}
		return false;
	}
	function process_button ()
	{
		return false;
	}
	function before_process ()
	{
		return false;
	}
	function payment_action ()
	{
		global $order, $xtPrice, $insert_id;
		$customerid = $_SESSION['customer_id'];
		$orderid = $insert_id;
		$_SESSION['cart_mp_elv_ID'] = $_SESSION['cart']->cartID . '-' . $insert_id;
		$my_currency = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_CURRENCY;
		if ($_SESSION['customers_status']['customers_status_show_price_tax'] == 0 && $_SESSION['customers_status']['customers_status_add_tax_ot'] == 1) {
			$total = $order->info['total'] + $order->info['tax'];
		} else {
			$total = $order->info['total'];
		}
		if ($_SESSION['currency'] == $my_currency) {
			$amount = round($total, $xtPrice->get_decimal_places($my_currency));
			//	$shipping = round($order->info['shipping_cost'], $xtPrice->get_decimal_places($my_currency));
		} else {
			$amount = round($xtPrice->xtcCalculateCurrEx($total, $my_currency), $xtPrice->get_decimal_places($my_currency));
			// 	$shipping = round($xtPrice->xtcCalculateCurrEx($order->info['shipping_cost'], $my_currency), $xtPrice->get_decimal_places($my_currency));
		}
		// Fix for XTC Bug
		// $order->info['total'] is in 'before_process' String without Tax, after email it is TEXT with currency
		// so it has to be set here
		$amount = number_format($amount, 2, '.', '');
		$_SESSION['mp_elv_total'] = $amount;

		$parameter = array();
		$parameter['account']     = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_USER_ID; // Ihre Kundennummer bei Micropayment.
		$parameter['project']     = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PROJECT_ID; // Ihre Projektnummer bei Micropayment, zu der die Zahlung gehoehrt.
		$parameter['amount']      = $amount * 100; // Zahlungsbetrag der an Sie uebermittelt werden soll
		$parameter['currency']    = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_CURRENCY;
		$parameter['title']       = STORE_NAME . ' ' . $order->customer['firstname'] . ' ' . $order->customer['lastname'];
		$parameter['auth']        = '';
		$parameter['country']     = $order->customer['country']['iso_code_2'];
		$parameter['customerid']  = $customerid;
		$parameter['orderid']     = $orderid;
//		$parameter['XTCsid']      = $order->customer['csID'];
		$parameter['XTCsid']      = str_replace('XTCsid=', '', SID);

	      if (xtc_not_null(MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PAGEDESIGN_TEMPLATE)) {
			$parameter['theme'] = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PAGEDESIGN_TEMPLATE;
		}

		if (xtc_not_null(MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PAGEDESIGN_LOGO)) {
			$parameter['gfx'] = MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PAGEDESIGN_LOGO;
		}


		$connector = NULL;
		foreach ($parameter as $key => $value) {
			$para .= $connector . $key . '=' . urlencode(stripslashes($value));
			if(empty($connector)) $connector = '&'; 
		}

		if (xtc_not_null(MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PROJECT_PASSWORD)) {

			$seal               = md5($para . MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PROJECT_PASSWORD);
			$parameter['seal']  = $seal;
			$para              .= '&seal='.$parameter['seal'];
		}

		$dataString = $para;

		xtc_redirect($this->form_action_url . '?' . $dataString);
	}
	function after_process ()
	{
		global $insert_id, $_GET;

		return false;
	}
	function output_error ()
	{
		return false;
	}
	function check ()
	{
		if (! isset($this->_check)) {
			$check_query = xtc_db_query("SELECT configuration_value FROM " . TABLE_CONFIGURATION . " WHERE configuration_key = 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_STATUS'");
			$this->_check = xtc_db_num_rows($check_query);
		}
		return $this->_check;
	}
	function get_error ()
	{
		$error = false;
		if (! empty($_GET['payment_error'])) {
			$error = array('title' => MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_REDIRECT_ERROR_HEADING , 'error' => MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_REDIRECT_TEXT_ERROR_MESSAGE);
		}
		return $error;
	}
	function install ()
	{
		global $_GET;
		$account = (! empty($_GET['account'])) ? xtc_db_prepare_input($_GET['account']) : '10000';
		$project = (! empty($_GET['project'])) ? xtc_db_prepare_input($_GET['project']) : 'krzel';
		$project_passwort = (! empty($_GET['project_passwort'])) ? xtc_db_prepare_input($_GET['project_passwort']) : '';
		$currency = (! empty($_GET['currency'])) ? xtc_db_prepare_input($_GET['currency']) : 'EUR';
		$check_query = xtc_db_query("SELECT orders_status_id FROM " . TABLE_ORDERS_STATUS . " WHERE orders_status_name = '" . MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_TMP_STATUS_NAME . "' limit 1");
		if (xtc_db_num_rows($check_query) < 1) {

			/*
      $status_query = xtc_db_query("SELECT max(orders_status_id) as status_id FROM " . TABLE_ORDERS_STATUS);
      $status = xtc_db_fetch_array($status_query);

      $status_id = $status['status_id']+1;
      */
			// download products have a min orderstatus, as this is a temp stauts it has to be lower
			$status_id = '-999';
			$languages = xtc_get_languages();
			for ($i = 0, $n = sizeof($languages); $i < $n; $i ++) {
				xtc_db_query("INSERT INTO " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . $languages[$i]['id'] . "', '" . MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_TMP_STATUS_NAME . "')");
			}
		} else {
			$check = xtc_db_fetch_array($check_query);
			$status_id = $check['orders_status_id'];
		}
		// update order table to store transaction details
		$check_query = xtc_db_query("show columns FROM " . TABLE_ORDERS . "  like 'mp_elv_transaktions_details'");
		if (xtc_db_num_rows($check_query) < 1) {
			xtc_db_query("ALTER TABLE " . TABLE_ORDERS . " ADD mp_elv_transaktions_details text not null");
		}
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_STATUS', 'False', '91', '3', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ALLOWED', '', '91', '0', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_USER_ID', '" . (int) $account . "',  '91', '4', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PROJECT_ID', '" . (int) $project . "',  '91', '4', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PROJECT_PASSWORD', '" . xtc_db_input($project_passwort) . "',  '91', '4', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_CURRENCY', '" . $currency . "',  '91', '6', 'xtc_cfg_select_option(array(\'EUR\'), ', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_SORT_ORDER', '0.6', '91', '0', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ZONE', '0', '91', '2', 'xtc_get_zone_class_title', 'xtc_cfg_pull_down_zone_classes(', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ORDER_STATUS_ID', '0',  '91', '0', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_TMP_STATUS_ID', '" . $status_id . "',  '91', '8', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_UNC_STATUS_ID', '0',  '91', '8', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PAGEDESIGN_TEMPLATE', '',  '91', '4', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PAGEDESIGN_LOGO', '',  '91', '4', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_DEBUG_EMAIL', '',  '91', '4', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_MIN_TOTAL', '1',  '91', '4', now())");
		xtc_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_MAX_TOTAL', '500',  '91', '4', now())");

	}
	function remove ()
	{
		xtc_db_query("DELETE FROM " . TABLE_CONFIGURATION . " WHERE configuration_key IN ('" . implode("', '", $this->keys()) . "')");
	}
	function keys ()
	{
		return array('MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_STATUS' , 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ALLOWED' , 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_USER_ID' , 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PROJECT_ID' , 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PROJECT_PASSWORD' , 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ZONE' , 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_CURRENCY' , 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PAGEDESIGN_TEMPLATE' , 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_PAGEDESIGN_LOGO' , 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_TMP_STATUS_ID' , 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_UNC_STATUS_ID' , 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_ORDER_STATUS_ID' , 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_SORT_ORDER', 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_DEBUG_EMAIL', 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_MIN_TOTAL', 'MODULE_PAYMENT_MICROPAYMENT_ELV_IPN_MAX_TOTAL');
	}
}
?>